#ifndef __CONFIG__
#define __CONFIG__

#include<stdio.h>
#include<stdlib.h>

#include"stack.h"
#include"queue.h"
#include"depset.h"
#include"mcd.h"
#include"feat_vec.h"
#include"global_feat_vec.h"

#define config_get_stack(c) (c)->st
#define config_get_buffer(c) (c)->bf
#define config_get_depset(c) (c)->ds

typedef struct {
  stack *st;            /* the stack */
  queue *bf;            /* the buffer */
  depset *ds;           /* the dependency set */
  FILE *f;              /* file from which words are read */
  mcd *mcd_struct;      /* description of the format of file f */
  float score;          /* score of the configuration */
  int *mvt_array;       /* array containing the movement sequence that led to this configuration */
  int mvt_array_size;   /* self explanatory */
  int mvt_array_nbelem; /* self explanatory */
  global_feat_vec *gfv; /* global feature vector for structured perceptron */
  int current_index;    /* index of current word (useful for stream parsing only) */

} config;

int config_equal(config *c1, config *c2);
int config_equal2(config *c1, config *c2);
config *config_new(FILE *f, mcd *mcd_struct);
config *config_initial(FILE *f, mcd *mcd_struct, int lookahead);
config *config_initial_no_dummy_word(FILE *f, mcd *mcd_struct, int lookahead);
config *config_copy(config *o);
void config_print(FILE *buffer, config *c);
int config_is_terminal(config *c);
void config_free(config *c);
void config_add_mvt(config *c, int mvt);
word *config_add_next_word_to_buffer(config *c);
void config_connect_subtrees(config *c, int root_label);



#endif
