#ifndef __FEATURE_TABLE__
#define __FEATURE_TABLE__
#include"dico.h"
#include"feat_vec.h"

typedef struct 
{
  int features_nb;
  int classes_nb;
  float **table;
} feature_table;


typedef struct {
  int class_code;
  float score;
} vcode;

feature_table *feature_table_load(char *filename, int verbose);
void feature_table_dump(char *filename, feature_table *ft);
feature_table *feature_table_new(int features_nb, int classes_nb);
void feature_table_print(char *filename, feature_table *ft);
void feature_table_print_verbose(char *filename, feature_table *ft, dico *dico_features, dico *dico_classes);
int feature_table_argmax(feat_vec *fv, feature_table *ft, float *max);
void feature_table_free(feature_table *ft);
void feature_table_scores(feat_vec *fv, feature_table *ft, float *classes_score);
vcode* feature_table_get_vcode_array(feat_vec *fv, feature_table* ft);
#endif
